﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication8
{
    public partial class MainWindow : Window
    {
        public ObservableCollection<Test> Items { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            DataContext = this;

            Items = new ObservableCollection<Test>();

            Items.Add(new Test1() { Label = "root" });
            Items[0].Children.Add(new Test1() { Label = "aaa" });
            Items[0].Children.Add(new Test1() { Label = "bbb" });
            Items[0].Children.Add(new Test1() { Label = "ccc" });
            Items[0].Children[0].Children.Add(new Test2() { Label = "aaa" });
            Items[0].Children[0].Children.Add(new Test2() { Label = "ddd" });
            Items[0].Children[0].Children.Add(new Test2() { Label = "eee" });
            Items[0].Children[0].Children.Add(new Test2() { Label = "fff" });
            Items[0].Children[0].Children[0].Children.Add(new Test2() { Label = "aaa" });
            Items[0].Children[0].Children[0].Children.Add(new Test2() { Label = "ggg" });
        }

        private void btn1_Click(object sender, RoutedEventArgs e)
        {
            Items[0].Children.RemoveAt(1);
        }
    }

    public class Test : INotifyPropertyChanged
    {
        #region Enabled
        private bool enabled;
        public bool Enabled
        {
            get { return enabled; }
            set
            {
                if (enabled != value)
                {
                    enabled = value;
                    RaisePropertyChanged("Enabled");
                }
            }
        }
        #endregion

        public string Label { get; set; }

        private bool expanded;
        public bool Expanded
        {
            get { return expanded; }
            set
            {
                if (expanded != value)
                {
                    expanded = value;
                    RaisePropertyChanged("Expanded");                  
                }
            }
        }

        public ObservableCollection<Test> Children { get; set; }

        public Test()
        {
            Expanded = false;
            Enabled = true;
            Children = new ObservableCollection<Test>();
        }

        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        #endregion
    }

    public class Test1 : Test
    {
    }

    public class Test2 : Test
    {
    }
}
